
#include <iom128.h>



#define TC  0x9c
//#define ADC_VREF_TYPE 0x00  //ADC 10bit Mode
#define ADC_VREF_TYPE 0x20  //ADC 8bit Mode
#define ADC_EOC (ADCSRA & 0x10)
#define ADC_START (ADCSRA |= 0x40)

void Init_Module()
{
	DDRA = 0xFF;    //PORTA : Output Only
  	PORTA = 0x00;	//PORTA ʱȭ
	DDRB = 0XFF;	//PORTB : Output Only
	PORTB = 0x00;	//PORTB ʱȭ
	DDRC = 0xFF;
	PORTC = 0x00;
	DDRF = 0x00;	
	PORTF = 0x00;
  
	UCSR1A = 0x00;
	UCSR1B=0x98;	//USART1 Control and Status Register B 
	UBRR1H=0x00;	//USART1 Baud Rate Register High
	UBRR1L=103;   	// 16Mhz 9600bps 	(	16M / (103+1) = 9615 	)
	//UBRR1L=8;   	// 16Mhz 115200bps 	(	16M / (8+1) = 111111.1 	)
	
	ACSR=0x80;
	ADCSRA=0x87;
// ADC initialization
// ADC Clock frequency: 125.000 kHz
// ADC Voltage Reference: AREF pin
	ADMUX = ADC_VREF_TYPE;
  

	ASSR=0x00;		//Asynchronous mode Status Register
	TCCR0=0x02;		//Timer/Counter 0 Control Register	//clkT0S/8 (From prescaler) = 20MHz /8 = 2.5Mhz -> 0.4us = 400ns
	TCNT0=TC;		//Timer/Counter 0
	OCR0=0x00;		//Timer/Counter 0 Output Compare Register

	TIMSK=0x01;   	//Timer/Counter Interrupt Mask Register 
}

unsigned char ReadADC(unsigned char channel)
{
	//unsigned char bFlag = 1;
  	ADMUX = ADC_VREF_TYPE | channel; //VREF  ̿

    ADC_START;
	while(!ADC_EOC);
        /*
	while(bFlag)
	{
	  if (ADC_EOC)
		bFlag = 0;
	}
        */
    return(ADCH);
}

void LDM_Sleep(unsigned int nTime)
{
	while(nTime--);
}