

#include <iom128.h>
#include <ina90.h>
#include <avr_macros.h>
#include <stdio.h>
#include <string.h>

  
#include "var.h"
#include "uart.h"
#include "motion.h"
#include "functions.h"

#define TC  0x9c
//#define ADC_VREF_TYPE 0x00  //ADC 10bit Mode
#define ADC_VREF_TYPE 0x20  //ADC 8bit Mode
#define ADC_EOC (ADCSRA & 0x10)
#define ADC_START (ADCSRA |= 0x40)




unsigned char  h=0, w=0;
int pic_delay = 0;


#pragma vector=TIMER0_OVF_vect
__interrupt void TIMER0_OVF_interrupt(void)
{
	if(copy_ing)
	{//data  ϴ  
		switch(motion_intdex)
		{
		case 1:
			FaceBuffer[h][w] = MOTION1[SelectFace][h][w];
			break;
		case 2:
			FaceBuffer[h][w] = MOTION2[SelectFace][h][w];
			break;
		case 3:
			FaceBuffer[h][w] = MOTION3[SelectFace][h][w];
			break;
		case 4:
			FaceBuffer[h][w] = MOTION4[SelectFace][h][w];
			break;
		case 5:
			FaceBuffer[h][w] = MOTION5[SelectFace][h][w];
			break;
		case 6:
			FaceBuffer[h][w] = MOTION6[SelectFace][h][w];
			break;
		case 7:
			FaceBuffer[h][w] = MOTION7[SelectFace][h][w];
			break;
		case 100:
			FaceBuffer[h][w] = SynchBuffer[h][w];
			break;
		default:
			FaceBuffer[h][w] = X;
			break;
		}
		
		
		w++;
		if(w == 16)
		{
			w = 0;
			h++;
			if(h == 16)
			{
				h = 0;
				copy_ing = 0;
			}
		}
	}
	else
	{//ۿ DisplayArray 
		DisplayArray[h][w] = FaceBuffer[h][w];
		
		w++;
		if(w == 16)
		{
			w = 0;
			h++;
			if(h == 16)
			{
				h = 0;
				copy_ing = 1;
				//TIMSK=0x00;
			}
		}
		
	}
	TCNT0 = TC;
}


void DisplayAll()
{
	int i, j, gr;
	for(gr=0; gr<2; gr++)
	{
		i = 0;
		while(1)
		{    
			for(j=0;j<16;j++)
			{//data  
				if(gr == 0)
				{//green  
					if(DisplayArray[i][j] & G)
					{
						GREEN_ON;
						RED_OFF;     
					}
					else
					{
						GREEN_OFF;
						RED_OFF;
					}
				}
				else
				{//red  
					if(DisplayArray[i][j] & R)
					{
						RED_ON;
						GREEN_OFF;
					}
					else
					{
						RED_OFF;
						GREEN_OFF;
					}
				}
				CLOCK = 1; 	CLOCK = 0;
			} 
			OUT_ENABLE = 1; 
			LATCH = 0;	LATCH = 1;
			LDM_Sleep(10);
			//addrȭ 
			PORTA = (PORTA & 0xf0) | (i & 0x0f);
			LDM_Sleep(10);
			OUT_ENABLE = 0;
			if(++i==16)  break;
		}
	}
}

void ControlMotion(int index)
{
	int max_motion_count = 0;
	motion_intdex = index;
	unsigned char synch_ing = 0;
	
	switch(index)
	{
	case 1:
		max_motion_count = MAX_MOTION1_COUNT;
		break;
	case 2:
		max_motion_count = MAX_MOTION2_COUNT;
		break;
	case 3:
		max_motion_count = MAX_MOTION3_COUNT;
		break;
	case 4:
		max_motion_count = MAX_MOTION4_COUNT;
		break;
	case 5:
		max_motion_count = MAX_MOTION5_COUNT;
		break;
	case 6:
		max_motion_count = MAX_MOTION6_COUNT;
		break;
	case 7:
		max_motion_count = MAX_MOTION7_COUNT;
		break;
	case 100:
		synch_ing = 1;
		max_motion_count = 1;
		break;
	default:
		max_motion_count = 1;
		break;
	}
	
	
	
	
	
	if(++Loop>=50)
	{
		Loop = 0;
		SelectFace++;
		
		if(SelectFace >= max_motion_count)
		{
			SelectFace = 0;
		}
	}
	
	if(SelectFace_prev != SelectFace)
	{
		SelectFace_prev = SelectFace;
		//TxData(SelectFace);
		TIMSK = 0x01;
	}
	
	
	
}


void main(void)
{	
	Init_Module();
	__enable_interrupt();
	//unsigned char sensor = 0;
	
	
	while(1) 
	{	
		//sensor = ReadADC(7);
		
		DisplayAll();
    
		ControlMotion(g_motion_select);
	}
}
