


#define HEADER1		0xab
#define HEADER2		0xcd
#define EOD			0xef

#define MOTION_CHANGE	0x01
#define DRAW_FROM_PC	0x02

extern int g_motion_select;

void TxData(unsigned char data)   //1Byte Uart1 Saed
{
	while(!(UCSR1A & 0x20));//udre
	UDR1=data;
}


void putstring(char *c)
{
	int cc;
	for(cc=0;cc<strlen(c);cc++)
		TxData(c[cc]);
}

int rx_step = 0;
int synch_count = 0;
unsigned char g_motion_select_temp = 0;
unsigned char RX_DATA;
int w_synch = 0, h_synch = 0;

//  
// 0xAB(HEADER1) / 0xCD(HEADER2) / DataType[0x01] / Data / OxEF(EOD)
// DataType
//	0x01:  Motion Change
//
//
#pragma vector = USART1_RXC_vect
__interrupt void USART1_RXC_Handler(void)
{
	_CLI();
	
	RX_DATA = UDR1;
	ReciveData[nUARTRxCnt] = RX_DATA;

	//nUARTRxCnt++;
	
	
	
	switch(rx_step)
	{
	case 0://⺻   
		if(ReciveData[0] == HEADER1)
		{
			putstring("H1");
			nUARTRxCnt++;
			rx_step = 1;
		}
		break;
	case 1:
		if(ReciveData[1] == HEADER2)
		{
			putstring("H2");
			nUARTRxCnt++;
			rx_step = 2;
		}
		else
		{
			putstring("R");
			nUARTRxCnt = 0;
			rx_step = 0;
		}
		break;
	case 2:
		if(ReciveData[2] == MOTION_CHANGE)
		{
			putstring("MC");
			nUARTRxCnt++;
			rx_step = 10;
		}
		else if(ReciveData[2] == DRAW_FROM_PC)
		{
			putstring("DP");
			nUARTRxCnt++;
			synch_count = 0;
			w_synch = 0, h_synch = 0;
			rx_step = 20;
		}
		else
		{
			putstring("RS");
			nUARTRxCnt = 0;
			rx_step = 0;
		}
		break;
	case 10:
		TxData(RX_DATA);
		g_motion_select_temp = RX_DATA;
		nUARTRxCnt++;
		rx_step = 11;
		break;
	case 11:
		if(ReciveData[4] == EOD)
		{
			putstring("END");
			g_motion_select = g_motion_select_temp;
		}
		else
		{
			putstring("RS");
		}
		nUARTRxCnt = 0;
		rx_step = 0;
		break;
	
	case 20:	//Synchronous transfer
		if(++synch_count < 256)
		{
			SynchBuffer[h_synch][w_synch] = RX_DATA;
			
			TxData(synch_count);
			//TxData(h_synch);
			//TxData(w_synch);
			//TxData(RX_DATA);
			
			w_synch++;
			if(w_synch == 16)
			{
				w_synch = 0;
				h_synch++;
				if(h_synch == 16)
				{
				  h_synch = 0;
				}
			}
		}
		
		else
		{
			if(RX_DATA == EOD)
			{
				putstring("END ");
				g_motion_select = 100;
				nUARTRxCnt = 0;
				rx_step = 0;
			}
			else
			{
				putstring("ERR ");
				nUARTRxCnt = 0;
				rx_step = 0;
			}
		}
	
		
		break;
		
	
	}
		
	_SEI();
}





